ifupdown: save some 100+ bytes of code in addstr()
[oweals/busybox.git] / testsuite / testing.sh
index c1002a6aa8c6c1f0ea245171ca82c4ae88542570..e253e1aa6baffbbb8c1fb0fd8a7a98717697dbb7 100755 (executable)
@@ -6,9 +6,6 @@
 
 # This file defines two functions, "testing" and "optionflag"
 
-# The "testing" function must have the following environment variable set:
-#    COMMAND = command to execute
-#
 # The following environment variables may be set to enable optional behavior
 # in "testing":
 #    VERBOSE - Print the diff -u of each failed test case.
@@ -17,8 +14,8 @@
 #
 # The "testing" function takes five arguments:
 #      $1) Description to display when running command
-#      $2) Command line arguments to command"
-#      $3) Expected result (on stdout)"
+#      $2) Command line arguments to command
+#      $3) Expected result (on stdout)
 #      $4) Data written to file "input"
 #      $5) Data written to stdin
 #
@@ -42,9 +39,9 @@ export SKIP=
 
 optional()
 {
-  option="$OPTIONFLAGS" | egrep "(^|:)$1(:|\$)"
+  option=`echo "$OPTIONFLAGS" | egrep "(^|:)$1(:|\$)"`
   # Not set?
-  if [[ -z "$1" || -z "$OPTIONFLAGS" || ${#option} -ne 0 ]]
+  if [ -z "$1" ] || [ -z "$OPTIONFLAGS" ] || [ ${#option} -ne 0 ]
   then
     SKIP=""
     return
@@ -56,45 +53,102 @@ optional()
 
 testing ()
 {
+  NAME="$1"
+  [ -z "$1" ] && NAME=$2
+
   if [ $# -ne 5 ]
   then
-    echo "Test $1 has the wrong number of arguments" >&2
+    echo "Test $NAME has the wrong number of arguments ($# $*)" >&2
     exit
   fi
 
-  if [ -n "$DEBUG" ] ; then
-    set -x
-  fi
+  [ -n "$DEBUG" ] && set -x
 
   if [ -n "$SKIP" ]
   then
-    echo "SKIPPED: $1"
+    echo "SKIPPED: $NAME"
     return 0
   fi
 
   echo -ne "$3" > expected
   echo -ne "$4" > input
-  echo -n -e "$5" | eval "$COMMAND $2" > actual
+  [ -z "$VERBOSE" ] || echo "echo '$5' | $2"
+  echo -ne "$5" | eval "$2" > actual
   RETVAL=$?
 
   cmp expected actual > /dev/null
   if [ $? -ne 0 ]
   then
     FAILCOUNT=$[$FAILCOUNT+1]
-    echo "FAIL: $1"
-    if [ -n "$VERBOSE" ]
-    then
-      diff -u expected actual
-    fi
+    echo "FAIL: $NAME"
+    [ -n "$VERBOSE" ] && diff -u expected actual
   else
-    echo "PASS: $1"
+    echo "PASS: $NAME"
   fi
   rm -f input expected actual
 
-  if [ -n "$DEBUG" ]
-  then
-    set +x
-  fi
+  [ -n "$DEBUG" ] && set +x
 
   return $RETVAL
 }
+
+# Recursively grab an executable and all the libraries needed to run it.
+# Source paths beginning with / will be copied into destpath, otherwise
+# the file is assumed to already be there and only its library dependencies
+# are copied.
+
+function mkchroot
+{
+  [ $# -lt 2 ] && return
+
+  echo -n .
+
+  dest=$1
+  shift
+  for i in "$@"
+  do
+    [ "${i:0:1}" == "/" ] || i=$(which $i)
+    [ -f "$dest/$i" ] && continue
+    if [ -e "$i" ]
+    then
+      d=`echo "$i" | grep -o '.*/'` &&
+      mkdir -p "$dest/$d" &&
+      cat "$i" > "$dest/$i" &&
+      chmod +x "$dest/$i"
+    else
+      echo "Not found: $i"
+    fi
+    mkchroot "$dest" $(ldd "$i" | egrep -o '/.* ')
+  done
+}
+
+# Set up a chroot environment and run commands within it.
+# Needed commands listed on command line
+# Script fed to stdin.
+
+function dochroot
+{
+  mkdir tmpdir4chroot
+  mount -t ramfs tmpdir4chroot tmpdir4chroot
+  mkdir -p tmpdir4chroot/{etc,sys,proc,tmp,dev}
+  cp -L testing.sh tmpdir4chroot
+
+  # Copy utilities from command line arguments
+
+  echo -n "Setup chroot"
+  mkchroot tmpdir4chroot $*
+  echo
+
+  mknod tmpdir4chroot/dev/tty c 5 0
+  mknod tmpdir4chroot/dev/null c 1 3
+  mknod tmpdir4chroot/dev/zero c 1 5
+
+  # Copy script from stdin
+
+  cat > tmpdir4chroot/test.sh
+  chmod +x tmpdir4chroot/test.sh
+  chroot tmpdir4chroot /test.sh
+  umount -l tmpdir4chroot
+  rmdir tmpdir4chroot
+}
+